"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _managerApi = require("@storybook/manager-api");
var _react = _interopRequireWildcard(require("react"));
var _constants = require("../../constants");
var _getActiveLocale = require("../../utils/getActiveLocale");
var _validateConfig = require("../../utils/validateConfig");
var _Panel = require("../components/Panel");
var _Warning = require("../components/Warning");
var _LocaleButton = require("../components/LocaleButton");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function LocalePanel() {
  var _intlConfig$locales;
  var intlConfig = (0, _managerApi.useParameter)(_constants.PARAMETER_KEY);
  var error = (0, _validateConfig.validateConfig)(intlConfig);
  var _useGlobals = (0, _managerApi.useGlobals)(),
    _useGlobals2 = _slicedToArray(_useGlobals, 2),
    globals = _useGlobals2[0],
    updateGlobals = _useGlobals2[1];
  var intlGlobals = globals[_constants.GLOBALS_KEY];
  var locales = (_intlConfig$locales = intlConfig === null || intlConfig === void 0 ? void 0 : intlConfig.locales) !== null && _intlConfig$locales !== void 0 ? _intlConfig$locales : [];
  var activeLocale = (0, _getActiveLocale.getActiveLocale)(locales, intlGlobals === null || intlGlobals === void 0 ? void 0 : intlGlobals.activeLocale, intlConfig === null || intlConfig === void 0 ? void 0 : intlConfig.defaultLocale);
  var changeLocale = function changeLocale(nextActiveLocale) {
    updateGlobals(_defineProperty({}, _constants.GLOBALS_KEY, {
      activeLocale: nextActiveLocale
    }));
  };
  if (!!error) {
    /*#__PURE__*/_react["default"].createElement(_Warning.Warning, null, error === 'missing' ? /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement("pre", null, "storybook-addon-intl"), " is not configured.") : /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement("pre", null, "storybook-addon-intl"), " is not configured correctly."));
  }
  return /*#__PURE__*/_react["default"].createElement(_Panel.Panel, null, locales.map(function (locale) {
    var handleClick = function handleClick() {
      changeLocale(locale);
    };
    return /*#__PURE__*/_react["default"].createElement(_LocaleButton.LocaleButton, {
      key: locale,
      active: locale === activeLocale,
      onClick: handleClick
    }, locale);
  }));
}
var _default = LocalePanel;
exports["default"] = _default;