"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withIntl = withIntl;
var _previewApi = require("@storybook/preview-api");
var _react = _interopRequireDefault(require("react"));
var _reactIntl = require("react-intl");
var _constants = require("../../constants");
var _validateConfig = require("../../utils/validateConfig");
var _getActiveLocale = require("../../utils/getActiveLocale");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function withIntl(StoryFn, context) {
  var _intlConfig$locales;
  var parameters = context.parameters;
  var intlConfig = parameters[_constants.PARAMETER_KEY];
  var error = (0, _validateConfig.validateConfig)(intlConfig);
  var _useGlobals = (0, _previewApi.useGlobals)(),
    _useGlobals2 = _slicedToArray(_useGlobals, 1),
    globals = _useGlobals2[0];
  var intlGlobals = globals[_constants.GLOBALS_KEY];
  var locales = (_intlConfig$locales = intlConfig === null || intlConfig === void 0 ? void 0 : intlConfig.locales) !== null && _intlConfig$locales !== void 0 ? _intlConfig$locales : [];
  var activeLocale = (0, _getActiveLocale.getActiveLocale)(locales, intlGlobals === null || intlGlobals === void 0 ? void 0 : intlGlobals.activeLocale, intlConfig === null || intlConfig === void 0 ? void 0 : intlConfig.defaultLocale);
  (0, _previewApi.useEffect)(function () {
    if (!!error || !activeLocale) {
      return;
    }
    document.documentElement.lang = activeLocale;
  }, [activeLocale]);
  if (!!error || !activeLocale) {
    return null;
  }
  var getMessages = intlConfig.getMessages,
    getFormats = intlConfig.getFormats,
    defaultRichTextElements = intlConfig.defaultRichTextElements;
  var messages = getMessages(activeLocale);
  var formats = typeof getFormats === 'function' ? getFormats(activeLocale) : undefined;
  return /*#__PURE__*/_react["default"].createElement(_reactIntl.IntlProvider, {
    locale: activeLocale,
    messages: messages,
    formats: formats,
    defaultRichTextElements: defaultRichTextElements
  }, StoryFn());
}