"use strict";

var _getActiveLocale = require("../getActiveLocale");
it("should return null if locale is an array ", function () {
  expect((0, _getActiveLocale.getActiveLocale)(null, 'de', 'en')).toBe(null);
});
it("should return default locale if active locale doesn't have a value", function () {
  expect((0, _getActiveLocale.getActiveLocale)(['en', 'de'], null, 'en')).toBe('en');
});
it("should return null if default locale is not a valid locale", function () {
  expect((0, _getActiveLocale.getActiveLocale)(['en', 'de'], null, 'es')).toBe(null);
});
it("should return active locale if it's a valid locale", function () {
  expect((0, _getActiveLocale.getActiveLocale)(['en', 'de'], 'de', 'en')).toBe('de');
});
it("should return default locale if active locale is not a valid locale", function () {
  expect((0, _getActiveLocale.getActiveLocale)(['en', 'de'], 'es', 'en')).toBe('en');
});